import sys, os, ConfigParser

PACKAGE_DIR = "/".join(os.path.abspath(__file__).split("/")[:-2])
CONFIG_DIR = PACKAGE_DIR + "/configs"

def initialize_settings(config_file):
    "given config file, return dictionary"

    config = ConfigParser.ConfigParser()
    config.read(config_file)

    settings = {}
    for section in config.sections():
        settings[section] = {}
        for name in config.options(section):
            settings[section][name] = config.get(section, name)

    return settings

def get_value(values, section, name):
    "given dictionay(values), section, and name, get value"

    if values.has_key(section) and values[section].has_key(name):
        return values[section][name]
    #can only change the parameters of the command for a given project, but not other stuff like command-memory
    elif values.has_key('commands') and values['commands'].has_key(name):
        return values['commands'][name]
    else:
        return None
    
def create_cmd(script, args_template, args_dict, source="%s/setup" % (PACKAGE_DIR), binary=False):
    args = args_template
    for field,value in args_dict.iteritems():
        args = args.replace(field, value)
    
    if not binary:
        cmd = "source %s;" % (source) + "time python " + script + ' ' + args
    else:
        cmd = "source %s;" % (source) + script + ' ' + args
        
    return cmd

if __name__ == '__main__':
    print CONFIG_DIR

