#!/usr/bin/env python

from optparse import OptionParser
import urllib

class Converter:
    
    def __init__(self, textfile):
	self.textfile = textfile

    def write_html(self, ofile, refdb, bed_file_url, psl_file_url):
	fhandle = open(self.textfile, 'r')
	ofhandle = open(ofile, 'w')
	# write header
	line = """<table class="data", border="1">\n"""
	ofhandle.write(line)
	line = '<tbody>' + '\n' + '<tr>' + '\n' + '<th ALIGN=left>Record</th>' + '\n' + '<th ALIGN=left>Screen</th>' + '\n' + '<th ALIGN=left>Read_support</th>' + '\n' + '<th ALIGN=left>Gene</th>' + '\n' + '<th ALIGN=left>Transcript</th>' + '\n' + '<th ALIGN=left>Event</th>' + '\n' + '<th ALIGN=left>Coordinate</th>' + '\n' + '<th ALIGN=left>Spanning_reads</th>' + '\n' + '<th ALIGN=left>Contig_coverage</th>' + '\n' + '<th ALIGN=left>Contig</th>' + '\n' + '<th ALIGN=left>Contig_neighbor</th>' + '\n' + '<th ALIGN=left>Exons</th>' + '\n' + '<th ALIGN=left>Align_blocks</th>' + '\n' + '<th ALIGN=left>Genome_coord</th>' + '\n' + '<th ALIGN=left>Orf</th>' + '\n' + '<th ALIGN=left>Splice</th>' + '\n' + '<th ALIGN=left>3x</th>' + '</tr>' + '\n'
	ofhandle.write(line)
	# create live links
	
	# create live links for the first coordinate
	index = 1
	line_first = fhandle.next()
	line_first = line_first[:-1]
	line_first_list = line_first.split(' ')
	position=line_first_list[5]
	position_quoted = urllib.quote_plus(position)
	url = "http://genome.ucsc.edu/cgi-bin/hgTracks?db=%s&position=%s&pix=800&Submit=submit" % (refdb, position_quoted) 
	extra_url_bed = bed_file_url
	extra_url_psl = psl_file_url
	extra_url = extra_url_psl + '\n' + extra_url_bed  
	extra_url_bit = urllib.quote_plus(extra_url)
	url = url + "&hgct_customText=%s" % extra_url_bit
	url_string = """<a href="%s">%s</a>""" % (url, position)
	line_first_list[5] = url_string 
	new_line = '<tr>'
	new_line = new_line + '<td>' + str(index) + '</td>' + ' ' 
	for item in line_first_list:
		if ('failed' in item):
			item_new = '<td bgcolor="#FF0000">' + item + '</td>'
		elif ('passed' in item):
			item_new = '<td bgcolor="#00FF00">' + item + '</td>'
		else:
			item_new = '<td>' + item + '</td>'
		new_line = new_line + item_new + ' '
	new_line = new_line + '</tr>' + '\n'
	ofhandle.write(new_line)
	for linenum, line in enumerate(fhandle):
		line = line[:-1]
		linelist = line.split(' ')
		new_line = '<tr>'
		index = index + 1
		new_line = new_line + '<td>' + str(index) + '</td>' + ' '
		for item in linelist:
			if ('chr' in item):
				position = item
				position_quoted = urllib.quote_plus(position) 
				url = "http://genome.ucsc.edu/cgi-bin/hgTracks?db=%s&position=%s&pix=800&Submit=submit" % (refdb, position_quoted)
				url_string = """<a href="%s">%s</a>""" % (url, position)
				item_new = '<td>' + url_string + '</td>'
                        elif ('failed' in item):
                                item_new = '<td bgcolor="#FF0000">' + item + '</td>'
                        elif ('passed' in item):
                                item_new = '<td bgcolor="#00FF00">' + item + '</td>'

			else:
				item_new = '<td>' + item + '</td>'
			new_line = new_line + item_new + ' '
		new_line = new_line + '</tr>' + '\n'
		ofhandle.write(new_line)
	# write footer
	line = '</tbody>' + '\n' + '</table>' + '\n'
	ofhandle.write(line)
	fhandle.close()
	ofhandle.close()

if __name__ == '__main__':

	parser = OptionParser()
	parser.add_option('-i', '--input-file', dest='in_file', help='input novelty text file')
	parser.add_option('-o', '--output-file', dest='out_file', help='output novelty html file')
	parser.add_option('-d', '--db', dest='db', help='reference genome')
	parser.add_option('-b', '--bed-file-url', dest='bed_file_url', help='bed file url')
	parser.add_option('-p', '--psl-file-url', dest='psl_file_url', help='psl file url')
	(options, args) = parser.parse_args()

	if (options.in_file and options.out_file and options.db and options.bed_file_url and options.psl_file_url):
		htmlparser = Converter(options.in_file)
		htmlparser.write_html(options.out_file, options.db, options.bed_file_url, options.psl_file_url)
	else:
	    print ('please use --help')
	   
