"""
modified from Richard's group's 'qseq2fastq.py'
"""

import sys
from cStringIO import StringIO

shift31 = {'@':'!','A':'"','B':'#','C':'$','D':'%','E':'&','F':'\'','G':'(','H':')','I':'*','J':'+','K':',','L':'-','M':'.','N':'/','O':'0','P':'1','Q':'2','R':'3','S':'4','T':'5','U':'6','V':'7','W':'8','X':'9','Y':':','Z':';','[':'<','\\':'=',']':'>','^':'?','_':'@','`':'A','a':'B','b':'C','c':'D','d':'E','e':'F','f':'G','g':'H','h':'I','i':'J','j':'K','k':'L','l':'M','m':'N','n':'O','o':'P','p':'Q','q':'R','r':'S','s':'T','t':'U','u':'V','v':'W','w':'X','x':'Y','y':'Z','z':'\[','\{':'\\','|':']','}':'^','~':'_'}


def asciiConvert(quality):
    asciList = [0]*len(quality)

    for position in range(len(quality)):
        asciList[position] = shift31[quality[position]]

    return asciList

def convert(qseq_file, fq_file):
    lc = 0
    tmp_data = StringIO()

    fq = open(fq_file, 'w')
    
    for line in open(qseq_file, 'r'):
        cols = line.rstrip("\n").split("\t")

        lc += 1

        converted_ascii = "".join(asciiConvert(cols[9]))

        tmp_data.write("@%s_%s:%s:%s:%s:%s/%s\n%s\n%s\n%s\n" % (cols[0], cols[1], cols[2], cols[3], \
                                    cols[4],cols[5],cols[7],cols[8],"+", converted_ascii))

        #flush to disk
        if lc == 10000:
            fq.write(tmp_data.getvalue())
            tmp_data = StringIO()
            lc = 0

    #write out the remainder at the end
    fq.write(tmp_data.getvalue())

    fq.close()
        
if __name__ == '__main__':   
    convert(sys.argv[1], sys.argv[2])
